--- old/usr/src/grub/grub-0.97/stage2/fsys_zfs.c	Mon Oct  7 19:17:14 2013
+++ new/usr/src/grub/grub-0.97/stage2/fsys_zfs.c	Mon Oct  7 19:17:14 2013
@@ -145,12 +145,13 @@
 	{{fletcher_4_native,	fletcher_4_byteswap},	1, 0,	"fletcher4"},
 	{{zio_checksum_SHA256,	zio_checksum_SHA256},	1, 0,	"SHA256"},
 	{{NULL,			NULL},			0, 0,	"zilog2"},
+	{{zio_checksum_SHA512,	NULL},			0, 0,	"SHA512"}
 };
 
 /*
  * zio_checksum_verify: Provides support for checksum verification.
  *
- * Fletcher2, Fletcher4, and SHA256 are supported.
+ * Fletcher2, Fletcher4, SHA-256 and SHA-512/256 are supported.
  *
  * Return:
  * 	-1 = Failure
@@ -966,6 +967,7 @@
  */
 static const char *spa_feature_names[] = {
 	"org.illumos:lz4_compress",
+	"org.illumos:sha512",
 	NULL
 };
 
